<template>
  <v-dialog v-model="dialogAnimal" @click:outside="close" max-width="50%">
    <v-card class="pa-8">
      <v-card-title class="justify-center text-h5 d-flex font-weight-bold">
        {{ dialogTitle }}
      </v-card-title>
      <v-divider class="mt-2 mb-6"></v-divider>

      <FlightsCaseAnimalForm v-if="paxs" :animal="animal" :paxs="paxs" />

      <v-card-actions class="justify-center d-flex">
        <v-btn variant="outlined" rounded size="large" data-cy="AnimalFormCloseBtn" class="text-uppercase" @click="close()">
          Annuler
        </v-btn>
        <v-btn variant="outlined" rounded size="large" data-cy="AnimalFormOkBtn" class="text-uppercase inverted" :disabled="!meta.valid"
          :loading="loading" @click="confirm()">
          Valider
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { Animal } from "~/dto/animal.dto";
import { Pax } from "~/dto/pax.dto";

const dialogAnimal = defineModel<boolean>()

const props = defineProps<{
  animal: Animal,
  paxs: Pax[]
}>();

const emit = defineEmits(['close', 'confirm'])

const { validate, meta } = useForm({
  initialValues: props.animal
})

const loading = ref(false);
const dialogTitle = ref('');

const close = () => {
  emit('close')
}

const confirm = async () => {
  const { valid } = await validate();
  if (!valid) {
    return;
  }
  emit('confirm');
  loading.value = true;
}

dialogTitle.value = props.animal.id ? `Édition d'un animal` : `Création d'un animal`;
</script>
